Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 733448 (CVE-2020-15859, CVE-2020-15863)

Summary: app-emulation/qemu: Use-after-free in hw/net/e1000e_core.c (CVE-2020-{15863,15859})
Product: Gentoo Security Reporter: John Helmert III <ajak>
Component: VulnerabilitiesAssignee: Gentoo Security <security>
Status: IN_PROGRESS ---    
Severity: minor CC: tamiko, virtualization
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
URL: https://bugs.launchpad.net/qemu/+bug/1886362
Whiteboard: B1 [??]
Package list:
Runtime testing required: ---
Bug Depends on: 725634    
Bug Blocks:    

Description John Helmert III gentoo-dev Security 2020-07-21 17:43:45 UTC
CVE-2020-15859:

QEMU 4.2.0 has a use-after-free in hw/net/e1000e_core.c because a guest OS user can trigger an e1000e packet with the data's address set to the e1000e's MMIO address.



Reporting because I'm not confident about the accuracy of the version in the CVE description. Maintainers, please confirm if we are vulnerable and if so create a patched version. There is a patch on qemu-devel:

https://lists.gnu.org/archive/html/qemu-devel/2020-07/msg05895.html
Comment 1 Sergei Trofimovich (RETIRED) gentoo-dev 2020-07-21 18:28:14 UTC
5.0 is probably affected as well. Given that it's a very delicate piece of NIC's MMIO emulation we'll wait on fix to land upstream.
Comment 2 John Helmert III gentoo-dev Security 2020-07-28 19:58:45 UTC
(In reply to John Helmert III (ajak) from comment #0)
> CVE-2020-15859:
> 
> QEMU 4.2.0 has a use-after-free in hw/net/e1000e_core.c because a guest OS
> user can trigger an e1000e packet with the data's address set to the
> e1000e's MMIO address.
> 
> 
> 
> Reporting because I'm not confident about the accuracy of the version in the
> CVE description. Maintainers, please confirm if we are vulnerable and if so
> create a patched version. There is a patch on qemu-devel:
> 
> https://lists.gnu.org/archive/html/qemu-devel/2020-07/msg05895.html

No patch for this yet as far as I can tell, but we have another vulnerability that is patched for 5.1.0-rc1.

CVE-2020-15863:

hw/net/xgmac.c in the XGMAC Ethernet controller in QEMU before 07-20-2020 has a buffer overflow. This occurs during packet transmission and affects the highbank and midway emulated machines. A guest user or process could use this flaw to crash the QEMU process on the host, resulting in a denial of service or potential privileged code execution. This was fixed in commit 5519724a13664b43e225ca05351c60b4468e4555.

Patch: https://git.qemu.org/?p=qemu.git;a=commitdiff;h=5519724a13664b43e225ca05351c60b4468e4555

qemu $ git tag --contains 5519724a13664b43e225ca05351c60b4468e4555
v5.1.0-rc1
Comment 3 John Helmert III gentoo-dev Security 2020-08-19 19:12:58 UTC
(In reply to John Helmert III (ajak) from comment #2)
> (In reply to John Helmert III (ajak) from comment #0)
> > CVE-2020-15859:
> > 
> > QEMU 4.2.0 has a use-after-free in hw/net/e1000e_core.c because a guest OS
> > user can trigger an e1000e packet with the data's address set to the
> > e1000e's MMIO address.
> > 
> > 
> > 
> > Reporting because I'm not confident about the accuracy of the version in the
> > CVE description. Maintainers, please confirm if we are vulnerable and if so
> > create a patched version. There is a patch on qemu-devel:
> > 
> > https://lists.gnu.org/archive/html/qemu-devel/2020-07/msg05895.html

I would be surprised if this is still unfixed, but I can't find where/if it made its way into git.
Comment 4 Sergei Trofimovich (RETIRED) gentoo-dev 2020-08-19 20:57:25 UTC
Upstream bug report is still open.
Comment 5 Matthias Maier gentoo-dev 2021-04-04 19:23:36 UTC
This has still not been resolved upstream.
Comment 6 John Helmert III gentoo-dev Security 2021-06-21 16:24:50 UTC
Fixed "a few months ago" according to upstream, not sure about fixed versions...